/*
   Tests your implementations of the static methods in the Expression class.
*/
import java.util.ArrayList;

public class TestExpressions
{
   public static void main(String[] args)
   {
      String[] expressions = {
                               "2 + 5 * 5",
                               "( ( 3 + 5 ) * 4 ) - 9",
                               "( 1 + 3 ) ^ 4 * 2 ^ 3",
                               "( 32 * 41 ) / 2 + 12 * 48"
                             };

      String[] postfix = new String[expressions.length];
      String[]   infix = new String[expressions.length];
      ArrayList<BinaryTree<String>> expTrees = new ArrayList<BinaryTree<String>>();
      int[] results = new int[expressions.length];

      for (int i = 0; i < expressions.length; i++)
      {
         System.out.println( expressions[i] );

         postfix[i] = Expression.Infix2Postfix( expressions[i] );

         System.out.println( postfix[i] );

         infix[i]   = Expression.postfix2Infix( postfix[i] );

         System.out.println( infix[i] );

         expTrees.add( Expression.infix2BinaryTree(infix[i]) );

         System.out.print( "Expression tree looks like:\n" + Expression.tree2String(expTrees.get(i)) );

         results[i] = Expression.evaluateExpressionTree((LinkedBinaryTree<String>)expTrees.get(i), expTrees.get(i).root());

         System.out.println( "Evaluates to " + results[i] );

         System.out.println("\n");
      }

   }//main
}//TestExpressions
